-- Exemplo 8 - Mux2 - Testbench
-- Arquitetura de Computadores
-- Prof. Erivelton
library ieee;
use ieee.std_logic_1164.all;
  
entity tb_Mux2 is
end tb_Mux2;
 
architecture behavior of tb_Mux2 is 
	-- Declaração de componente de: Unit Uder Test (UUT)
	component Mux2
	port (a,b,c,d : in  std_logic;
		sel : in  std_logic_vector (1 downto 0);
		out1 : out  std_logic);
    end component;
	-- Sinais
	signal a : std_logic;
	signal b : std_logic;
	signal c : std_logic;
	signal d : std_logic;
	signal sel : std_logic_vector (1 downto 0);
	signal out1 : std_logic;
	begin
	-- Definição the Unit Under Test (UUT)
	uut: Mux2 port map 
	(
		a => a,
		b => b,
		c => c,
		d => d,
		sel => sel,
		out1 => out1
	);
	-- Stimulus process
	stim_proc: process
	begin
		-- insert stimulus here 		
		wait for 5 ns;	
			a <= '0';
            b <= '1';
            c <= '0';
            d <= '1';
            sel <= "00";
		wait for 5 ns;	
			a <= '0';
            b <= '1';
            c <= '0';
            d <= '1';
            sel <= "01";			
		wait for 5 ns;	
			a <= '0';
            b <= '1';
            c <= '0';
            d <= '1';
            sel <= "10";			
		wait for 5 ns;	
			a <= '0';
            b <= '1';
            c <= '0';
            d <= '1';
            sel <= "11";			
		wait;
   end process;
end architecture;
